<!DOCTYPE html>
<html lang="en-us">
<title>Deterministic Ansible | Bakey.us - Blog</title>
<meta charset="utf-8">
<meta name="generator" content="Hugo 0.58.3" />
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<link rel="canonical" href="http://bakey.us/blog/posts/deterministic-ansible/">
<link rel="alternate" type="application/rss+xml" href="" title="Bakey.us - Blog">
<link rel="stylesheet" href="http://bakey.us/blog/css/theme.css">
<link rel="stylesheet" href="http://bakey.us/blog/css/classes.css">

<header class="dark">
  <h2><a href="http://bakey.us/blog/">Bakey.us - Blog</a></h2>
  <nav>
    
  </nav>
</header>

<article>
  <header>
    <h1><a href="http://bakey.us/blog/posts/deterministic-ansible/">Deterministic Ansible</a></h1>
    <p class="meta"><time datetime="2019-09-24T11:17:31-05:00">September 24, 2019</time></p>
  </header>
  

<p>Recently I had to deploy AppDynamics agents out to some systems that ran both tomcat and JBOSS workloads, and here&rsquo;s how I used one playbook to rule them all.</p>

<hr />

<h2 id="1-figure-out-which-platform-i-was-dealing-with">1 - Figure out which platform I was dealing with</h2>

<pre><code class="language-ansible">#check to see if we're tomcat or jboss
- name: Check to see if tomcat user exists
  stat:
    path: /home/tomcat8
  register: tomcat8

- name: check to see if jbossadm user exists
  stat:
    path: /home/jbossadm
  register: jbossadm
</code></pre>

<p>As you can see, I&rsquo;m doing a simple stat module check on the home directory of the user running the java workload here.  In our use case those 2 users would never coexist on a server.</p>

<h2 id="2-swap-ownership-on-files-folders-based-on-our-findings-above">2 - Swap ownership on files/folders based on our findings above</h2>

<pre><code class="language-ansible">#creates directory path
- name: Create the directories for site specific configurations owned by tomcat8
  file:
    path: /usr/local/appdynamics/appagent/
    state: directory
    owner: tomcat8
    group: tomcat8
    mode: 0755
  when: tomcat8.stat.exists

- name: Create the directories for site specific configurations owned by jbossadm
  file:
    path: /usr/local/appdynamics/appagent/
    state: directory
    owner: jbossadm
    group: jbossadm
    mode: 0755
  when: jbossadm.stat.exists
</code></pre>

<p>So, in each case we&rsquo;re creating the same folder path and changing linux file system ownership based on which platform we&rsquo;re running this ansible playbook on.</p>

<p>The <a href="https://docs.ansible.com/ansible/latest/modules/stat_module.html">stat</a> module and <a href="https://docs.ansible.com/ansible/latest/user_guide/playbooks_conditionals.html?highlight=conditionals#the-when-statement">when</a> conditions are pretty powerful tools you can use to make Ansible super flexible without having to pass a bunch of extra parameters in to control which tasks get executed in your playbooks.</p>

</article>



</html>
